diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lyap_spec__.cc
--- a/src/__lyap_spec__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lyap_spec__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -220,13 +220,6 @@
       Matrix solved      = mat.solve (vec);
       double *solved_arr = solved.fortran_vec ();
 
-    // If errors were raised (a singular matrix was encountered), 
-    // there is no sense in countinuing
-    if (error_state)
-      {
-        return ;
-      }
-
       double new_vec = solved_arr[0];
       for (octave_idx_type i=1;i<=alldim;i++)
         dynamics[d][i-1] = solved_arr[i];
@@ -419,149 +412,138 @@
         }
      // end old indexes = make_multi_index();
 
-      if (!error_state)
-        {
-
-          // Promote warnings connected with singular matrixes to errors
-          set_warning_state ("Octave:nearly-singular-matrix","error");
-          set_warning_state ("Octave:singular-matrix","error");
+      // Promote warnings connected with singular matrixes to errors
+      set_warning_state ("Octave:nearly-singular-matrix","error");
+      set_warning_state ("Octave:singular-matrix","error");
 
-          // Prepare data for running first time
-          if (count == 0)
-            {
-              averr_matrix.fill (0.0);
+      // Prepare data for running first time
+      if (count == 0)
+        {
+          averr_matrix.fill (0.0);
 
-              if (epsset)
-                epsmin /= maxinterval;
+          if (epsset)
+            epsmin /= maxinterval;
 
-              // old rnd_init(0x098342L);
-              TISEAN_rand generator (0x098342L);
-              for (octave_idx_type i=0;i<10000;i++)
-                generator.rnd_long();
-              for (octave_idx_type i=0;i<alldim;i++) {
-                factor[i]=0.0;
-                for (octave_idx_type j=0;j<alldim;j++)
-                  delta[i][j] = (double)generator.rnd_long()
-                                / (double)std::numeric_limits<octave_idx_type>
-                                          ::max ();
-              }
-              gram_schmidt(alldim, delta,lfactor);
+          // old rnd_init(0x098342L);
+          TISEAN_rand generator (0x098342L);
+          for (octave_idx_type i=0;i<10000;i++)
+            generator.rnd_long();
+          for (octave_idx_type i=0;i<alldim;i++) {
+            factor[i]=0.0;
+            for (octave_idx_type j=0;j<alldim;j++)
+              delta[i][j] = (double)generator.rnd_long()
+                            / (double)std::numeric_limits<octave_idx_type>
+                                      ::max ();
+          }
+          gram_schmidt(alldim, delta,lfactor);
 
-              avneig = 0.0;
-              aveps  = 0.0;
-            }
+          avneig = 0.0;
+          aveps  = 0.0;
+        }
 
-          // Create output
-          Matrix lyap_exp (1, 1 + alldim);
-          time_t lasttime;
-          time(&lasttime);
-          bool pause_calc = false;
-          for (octave_idx_type i = count + (EMBED-1) * DELAY;
-               i < ITERATIONS && !pause_calc; i++)
+      // Create output
+      Matrix lyap_exp (1, 1 + alldim);
+      time_t lasttime;
+      time(&lasttime);
+      bool pause_calc = false;
+      for (octave_idx_type i = count + (EMBED-1) * DELAY;
+           i < ITERATIONS && !pause_calc; i++)
+        {
+          count++;
+          make_dynamics(series, box, indexes, epsmin, epsset, EPSSTEP,
+                        EMBED, MINNEIGHBORS, LENGTH, DIMENSION, count,
+                        avneig, aveps, dynamics, averr, i);
+          make_iteration(DIMENSION, alldim, dynamics, delta);
+          gram_schmidt(alldim, delta,lfactor);
+          for (octave_idx_type j=0;j<alldim;j++) {
+            factor[j] += log(lfactor[j])/(double)DELAY;
+          }
+
+          if (((time(NULL)-lasttime) > OUT) || (i == (ITERATIONS-1))
+              || (count % it_pause == 0) )
             {
-              count++;
-              make_dynamics(series, box, indexes, epsmin, epsset, EPSSTEP,
-                            EMBED, MINNEIGHBORS, LENGTH, DIMENSION, count,
-                            avneig, aveps, dynamics, averr, i);
-              // If there was an error
-              // (matrix singularity or not enough neighbors)
-              // No sense continuing
-              if (error_state)
+              time(&lasttime);
+
+              // Create spectrum output
+              // old fprintf(stdout,"%ld ",count);
+              lyap_exp(0,0) = count;
+              for (octave_idx_type j=0;j<alldim;j++)
                 {
-                  return retval;
+                  // old fprintf(stdout,"%e ",factor[j]/count);
+                  lyap_exp(0, 1+j) = factor[j]/count;
                 }
-              make_iteration(DIMENSION, alldim, dynamics, delta);
-              gram_schmidt(alldim, delta,lfactor);
-              for (octave_idx_type j=0;j<alldim;j++) {
-                factor[j] += log(lfactor[j])/(double)DELAY;
-              }
 
-              if (((time(NULL)-lasttime) > OUT) || (i == (ITERATIONS-1))
-                  || (count % it_pause == 0) )
-                {
-                  time(&lasttime);
-
-                  // Create spectrum output
-                  // old fprintf(stdout,"%ld ",count);
-                  lyap_exp(0,0) = count;
-                  for (octave_idx_type j=0;j<alldim;j++)
-                    {
-                      // old fprintf(stdout,"%e ",factor[j]/count);
-                      lyap_exp(0, 1+j) = factor[j]/count;
-                    }
+              pause_calc = true;
+            }
+        }
 
-                  pause_calc = true;
-                }
-            }
-
-          // Create pause output
-          if (count < (ITERATIONS - (EMBED-1)*DELAY))
-            {
-              octave_scalar_map pause_vars;
-              pause_vars.setfield ("averr", averr_matrix);
-              pause_vars.setfield ("delta", delta_matrix);
-              pause_vars.setfield ("count", count);
-              pause_vars.setfield ("avneig", avneig);
-              pause_vars.setfield ("aveps", aveps);
-              pause_vars.setfield ("epsmin", epsmin);
-              retval(0) = lyap_exp; 
-              retval(1) = pause_vars;
-            }
+      // Create pause output
+      if (count < (ITERATIONS - (EMBED-1)*DELAY))
+        {
+          octave_scalar_map pause_vars;
+          pause_vars.setfield ("averr", averr_matrix);
+          pause_vars.setfield ("delta", delta_matrix);
+          pause_vars.setfield ("count", count);
+          pause_vars.setfield ("avneig", avneig);
+          pause_vars.setfield ("aveps", aveps);
+          pause_vars.setfield ("epsmin", epsmin);
+          retval(0) = lyap_exp; 
+          retval(1) = pause_vars;
+        }
 
-          // Create final output
-          if (count == (ITERATIONS - (EMBED-1)*DELAY))
-            {
-              double dim=0.0;
-              octave_idx_type i;
-              for (i=0;i<alldim;i++) {
-                dim += factor[i];
-                if (dim < 0.0)
-                  break;
-              }
-              if (i < alldim)
-                dim=i+(dim-factor[i])/fabs(factor[i]);
-              else
-                dim=alldim;
+      // Create final output
+      if (count == (ITERATIONS - (EMBED-1)*DELAY))
+        {
+          double dim=0.0;
+          octave_idx_type i;
+          for (i=0;i<alldim;i++) {
+            dim += factor[i];
+            if (dim < 0.0)
+              break;
+          }
+          if (i < alldim)
+            dim=i+(dim-factor[i])/fabs(factor[i]);
+          else
+            dim=alldim;
 
-              // Create output pars
-              octave_scalar_map pars;
+          // Create output pars
+          octave_scalar_map pars;
 
-              // Create rel_err
-              Matrix rel_err (1, DIMENSION);
-              // old fprintf(stdout,"#Average relative forecast errors:= ");
-              for (octave_idx_type i=0;i<DIMENSION;i++)
-                {
-                  // old fprintf(stdout,"%e ",sqrt(averr[i]/count)/var[i]);
-                  rel_err(0,i) = sqrt(averr[i]/count)/var[i];
-                }
-              pars.setfield ("rel_err", rel_err);
+          // Create rel_err
+          Matrix rel_err (1, DIMENSION);
+          // old fprintf(stdout,"#Average relative forecast errors:= ");
+          for (octave_idx_type i=0;i<DIMENSION;i++)
+            {
+              // old fprintf(stdout,"%e ",sqrt(averr[i]/count)/var[i]);
+              rel_err(0,i) = sqrt(averr[i]/count)/var[i];
+            }
+          pars.setfield ("rel_err", rel_err);
 
-              // Create abs_err
-              Matrix abs_err (1, DIMENSION);
-              // old fprintf(stdout,"#Average absolute forecast errors:= ");
-              for (octave_idx_type i=0;i<DIMENSION;i++)
-                {
-                  // old fprintf(stdout,"%e ",sqrt(averr[i]/count)
-                  //                          *interval[i]);
-                  abs_err(0,i) = sqrt(averr[i]/count)*interval[i];
-                }
-              pars.setfield ("abs_err", abs_err);
+          // Create abs_err
+          Matrix abs_err (1, DIMENSION);
+          // old fprintf(stdout,"#Average absolute forecast errors:= ");
+          for (octave_idx_type i=0;i<DIMENSION;i++)
+            {
+              // old fprintf(stdout,"%e ",sqrt(averr[i]/count)
+              //                          *interval[i]);
+              abs_err(0,i) = sqrt(averr[i]/count)*interval[i];
+            }
+          pars.setfield ("abs_err", abs_err);
 
-              // old fprintf(stdout,"#Average Neighborhood Size= %e\n",
-              //             aveps*maxinterval/count);
-              pars.setfield ("nsize", aveps*maxinterval/count);
-
-              // old fprintf(stdout,"#Average num. of neighbors= %e\n",
-              //             avneig/count);
-              pars.setfield ("nno", avneig/count);
+          // old fprintf(stdout,"#Average Neighborhood Size= %e\n",
+          //             aveps*maxinterval/count);
+          pars.setfield ("nsize", aveps*maxinterval/count);
 
-              // old fprintf(stdout,"#estimated KY-Dimension= %f\n",dim);
-              pars.setfield ("ky_dim", dim);
+          // old fprintf(stdout,"#Average num. of neighbors= %e\n",
+          //             avneig/count);
+          pars.setfield ("nno", avneig/count);
 
-              // Assign output
-              retval(0) = lyap_exp;
-              retval(1) = pars;
-            }
+          // old fprintf(stdout,"#estimated KY-Dimension= %f\n",dim);
+          pars.setfield ("ky_dim", dim);
+
+          // Assign output
+          retval(0) = lyap_exp;
+          retval(1) = pars;
         }
     }
   return retval;
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lzo_gm__.cc
--- a/src/__lzo_gm__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lzo_gm__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -110,92 +110,89 @@
 
       MArray<octave_idx_type> box (dim_vector(NMAX,NMAX));
 
-      if ( ! error_state)
-        {
-          // Estimate maximum possible output size
-          octave_idx_type output_rows = (octave_idx_type)
-                                        ((log(EPS1) - log(EPS0)) / log (EPSF));
-          output_rows += 2;
+      // Estimate maximum possible output size
+      octave_idx_type output_rows = (octave_idx_type)
+                                    ((log(EPS1) - log(EPS0)) / log (EPSF));
+      output_rows += 2;
 
-          // Create output
-          Matrix output (output_rows,dim+4);
-          octave_idx_type count = 0;
+      // Create output
+      Matrix output (output_rows,dim+4);
+      octave_idx_type count = 0;
 
-          for (double epsilon=EPS0;epsilon<EPS1*EPSF;epsilon*=EPSF) 
+      for (double epsilon=EPS0;epsilon<EPS1*EPSF;epsilon*=EPSF) 
+        {
+          long pfound=0;
+          for (octave_idx_type i=0;i<dim;i++)
+            error_array[i]=hrms[i]=hav[i]=0.0;
+          double avfound=0.0;
+
+          make_multi_box(input,box,list,LENGTH-STEP,NMAX,dim,
+                         embed,delay,epsilon);
+          for (octave_idx_type i=(embed-1)*delay;i<clength;i++) 
             {
-              long pfound=0;
-              for (octave_idx_type i=0;i<dim;i++)
-                error_array[i]=hrms[i]=hav[i]=0.0;
-              double avfound=0.0;
-
-              make_multi_box(input,box,list,LENGTH-STEP,NMAX,dim,
-                             embed,delay,epsilon);
-              for (octave_idx_type i=(embed-1)*delay;i<clength;i++) 
+              for (octave_idx_type j=0;j<dim;j++)
                 {
-                  for (octave_idx_type j=0;j<dim;j++)
-                    {
-                      // old hser[j]=series[j]+i;
-                      hser[j] = input.fortran_vec() + j * LENGTH + i;
-                    }
-                  octave_idx_type actfound;
-                  actfound = find_multi_neighbors(input,box,list,hser,
-                                                  NMAX,dim,embed,delay,
-                                                  epsilon,hfound);
-                  actfound = exclude_interval(actfound,i-causal+1,
-                                             i+causal+(embed-1)*delay-1,
-                                             hfound,found);
-                  if (actfound > 2*(dim*embed+1)) 
-                    {
-                      make_fit (input, dim, i, actfound, STEP, found,
-                               error_array);
-                      pfound++;
-                      avfound += (double)(actfound-1);
-                      for (octave_idx_type j=0;j<dim;j++) {
-                        hrms[j] += input(i+STEP,j) * input(i+STEP,j);
-                        hav[j] += input(i+STEP,j);
-                      }
-                    }
+                  // old hser[j]=series[j]+i;
+                  hser[j] = input.fortran_vec() + j * LENGTH + i;
                 }
-              if (pfound > 1) 
+              octave_idx_type actfound;
+              actfound = find_multi_neighbors(input,box,list,hser,
+                                              NMAX,dim,embed,delay,
+                                              epsilon,hfound);
+              actfound = exclude_interval(actfound,i-causal+1,
+                                         i+causal+(embed-1)*delay-1,
+                                         hfound,found);
+              if (actfound > 2*(dim*embed+1)) 
                 {
-                  double sumerror=0.0;
-                  for (octave_idx_type j=0;j<dim;j++) 
-                    {
-                      hav[j] /= pfound;
-                      hrms[j]=sqrt(fabs(hrms[j]/(pfound-1)-hav[j]*hav[j]
-                                   * pfound/(pfound-1)));
-                      error_array[j]=sqrt(error_array[j]/pfound)/hrms[j];
-                      sumerror += error_array[j];
-                    }
-
-                  // Write output
-        // old fprintf(stdout,"%e %e ",epsilon*interval,sumerror/(double)dim);
-                  output(count, 0) = epsilon * interval;
-                  output(count, 1) = sumerror / (double) dim;
-                for (octave_idx_type j=0;j<dim;j++)
-                  {
-                    // old fprintf(stdout,"%e ",error_array[j]);
-                    output(count, 2 + j) = error_array[j];
+                  make_fit (input, dim, i, actfound, STEP, found,
+                           error_array);
+                  pfound++;
+                  avfound += (double)(actfound-1);
+                  for (octave_idx_type j=0;j<dim;j++) {
+                    hrms[j] += input(i+STEP,j) * input(i+STEP,j);
+                    hav[j] += input(i+STEP,j);
                   }
-            
-  //    old fprintf(stdout,"%e %e\n",(double)pfound/(clength-(embed-1)*delay),
-  //                                avfound/pfound);
-                output(count,2 + dim) = (double)pfound / 
-                                        (clength-(embed-1)*delay);
-                output(count,2 + dim + 1) = avfound/pfound;
-
-                count += 1;
                 }
             }
+          if (pfound > 1) 
+            {
+              double sumerror=0.0;
+              for (octave_idx_type j=0;j<dim;j++) 
+                {
+                  hav[j] /= pfound;
+                  hrms[j]=sqrt(fabs(hrms[j]/(pfound-1)-hav[j]*hav[j]
+                               * pfound/(pfound-1)));
+                  error_array[j]=sqrt(error_array[j]/pfound)/hrms[j];
+                  sumerror += error_array[j];
+                }
 
-          // Resize output to fit actual results instead of
-          // an educated guess
-          // if count == 0 then the output will be an 0x4+dim matrix
-          output.resize (count, dim + 4);
+              // Write output
+    // old fprintf(stdout,"%e %e ",epsilon*interval,sumerror/(double)dim);
+              output(count, 0) = epsilon * interval;
+              output(count, 1) = sumerror / (double) dim;
+            for (octave_idx_type j=0;j<dim;j++)
+              {
+                // old fprintf(stdout,"%e ",error_array[j]);
+                output(count, 2 + j) = error_array[j];
+              }
+        
+// old fprintf(stdout,"%e %e\n",(double)pfound/(clength-(embed-1)*delay),
+//                              avfound/pfound);
+            output(count,2 + dim) = (double)pfound / 
+                                    (clength-(embed-1)*delay);
+            output(count,2 + dim + 1) = avfound/pfound;
 
-          retval(0) = output;
+            count += 1;
+            }
+        }
 
-        }
+      // Resize output to fit actual results instead of
+      // an educated guess
+      // if count == 0 then the output will be an 0x4+dim matrix
+      output.resize (count, dim + 4);
+
+      retval(0) = output;
+
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lzo_run__.cc
--- a/src/__lzo_run__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lzo_run__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -209,90 +209,87 @@
 
       MArray<octave_idx_type> box (dim_vector(NMAX,NMAX));
 
-      if ( ! error_state)
-        {
-          for (octave_idx_type j=0;j<dim;j++)
-            for (octave_idx_type i=0;i<hdim;i++)
-              cast[i][j]=input(LENGTH-hdim+i,j);
+      for (octave_idx_type j=0;j<dim;j++)
+        for (octave_idx_type i=0;i<hdim;i++)
+          cast[i][j]=input(LENGTH-hdim+i,j);
 
-        // old  indexes=make_multi_index(dim,embed,DELAY);
+    // old  indexes=make_multi_index(dim,embed,DELAY);
 
-          octave_idx_type alldim=dim * embed;
+      octave_idx_type alldim=dim * embed;
 
-          MArray<octave_idx_type> indexes (dim_vector (alldim, 2));
-          for (octave_idx_type i=0;i<alldim;i++) 
-            {
-              indexes(i,0)=i%dim;
-              indexes(i,1)=(i/dim)*DELAY;
-            }
+      MArray<octave_idx_type> indexes (dim_vector (alldim, 2));
+      for (octave_idx_type i=0;i<alldim;i++) 
+        {
+          indexes(i,0)=i%dim;
+          indexes(i,1)=(i/dim)*DELAY;
+        }
 
-         // end old index = make_multi_index();
+     // end old index = make_multi_index();
 
-      //   old rnd_init(seed);
-          TISEAN_rand generator (seed);
+  //   old rnd_init(seed);
+      TISEAN_rand generator (seed);
 
-          double epsilon0=EPS0/EPSF;
+      double epsilon0=EPS0/EPSF;
 
-          if (setnoise) 
-            Q /= 100.0;
+      if (setnoise) 
+        Q /= 100.0;
 
-          Matrix output (FLENGTH, dim);
-          octave_idx_type row_count = 0;
-          octave_idx_type count = 1;
-          for (octave_idx_type i=0;i<FLENGTH;i++)
-            {
-              bool done=0;
-              double epsilon;
-              if (setsort)
-                epsilon= epsilon0/((double)count*EPSF);
-              else
-                epsilon=epsilon0;
-              while (!done) {
-                epsilon*=EPSF;
-                put_in_boxes(input, box, list, epsilon,(embed-1)*DELAY);
-                octave_idx_type actfound=hfind_neighbors(input, indexes, box,
-                                                         list, cast, found,
-                                                         epsilon,
-                                                         (embed-1) * DELAY);
-                if (actfound >= MINN) {
-                  if (setsort) {
-                    epsilon0 += epsilon;
-                    count++;
-                    sort(input, found, abstand, cast, actfound, (embed-1)*DELAY);
-                    actfound=MINN;
-                  }
-                  make_zeroth(input, generator, setnoise, var, Q, found,
-                              actfound, newcast);
+      Matrix output (FLENGTH, dim);
+      octave_idx_type row_count = 0;
+      octave_idx_type count = 1;
+      for (octave_idx_type i=0;i<FLENGTH;i++)
+        {
+          bool done=0;
+          double epsilon;
+          if (setsort)
+            epsilon= epsilon0/((double)count*EPSF);
+          else
+            epsilon=epsilon0;
+          while (!done) {
+            epsilon*=EPSF;
+            put_in_boxes(input, box, list, epsilon,(embed-1)*DELAY);
+            octave_idx_type actfound=hfind_neighbors(input, indexes, box,
+                                                     list, cast, found,
+                                                     epsilon,
+                                                     (embed-1) * DELAY);
+            if (actfound >= MINN) {
+              if (setsort) {
+                epsilon0 += epsilon;
+                count++;
+                sort(input, found, abstand, cast, actfound, (embed-1)*DELAY);
+                actfound=MINN;
+              }
+              make_zeroth(input, generator, setnoise, var, Q, found,
+                          actfound, newcast);
 
-                  for (octave_idx_type j=0;j<dim-1;j++)
-                  {
-                    // old printf("%e ",newcast[j]*interval[j]+min[j]);
-                    output(row_count, j) = newcast[j]*interval[j]+min[j];
-                  }
-                  // old printf("%e\n",newcast[dim-1]*interval[dim-1]+min[dim-1]);
-                  output(row_count, dim-1) = newcast[dim-1]*interval[dim-1]
-                                             + min[dim-1];
-                  row_count += 1;
+              for (octave_idx_type j=0;j<dim-1;j++)
+                {
+                  // old printf("%e ",newcast[j]*interval[j]+min[j]);
+                  output(row_count, j) = newcast[j]*interval[j]+min[j];
+                }
+              // old printf("%e\n",newcast[dim-1]*interval[dim-1]+min[dim-1]);
+              output(row_count, dim-1) = newcast[dim-1]*interval[dim-1]
+                                         + min[dim-1];
+              row_count += 1;
 
-                  done=1;
-                  double *swap=cast[0];
-                  for (octave_idx_type j=0;j<hdim-1;j++)
-                    cast[j]=cast[j+1];
-                  cast[hdim-1]=swap;
-                  for (octave_idx_type j=0;j<dim;j++)
-                    cast[hdim-1][j]=newcast[j];
-                }
-              }
+              done=1;
+              double *swap=cast[0];
+              for (octave_idx_type j=0;j<hdim-1;j++)
+                cast[j]=cast[j+1];
+              cast[hdim-1]=swap;
+              for (octave_idx_type j=0;j<dim;j++)
+                cast[hdim-1][j]=newcast[j];
             }
+          }
+        }
 
-            if (row_count != 0)
-            {
-              output.resize (row_count, dim);
-              retval(0) = output;
-            }
-            else 
-              retval(0) = Matrix (0,0);
-        }
+        if (row_count != 0)
+          {
+            output.resize (row_count, dim);
+            retval(0) = output;
+          }
+        else 
+          retval(0) = Matrix (0,0);
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__lzo_test__.cc
--- a/src/__lzo_test__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__lzo_test__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -150,93 +150,90 @@
       MArray<octave_idx_type> box (dim_vector(NMAX, NMAX));
 
       // Compute forecast error
-      if ( ! error_state)
-        {
-          for (octave_idx_type i=0;i<LENGTH;i++)
-            done[i]=0;
+      for (octave_idx_type i=0;i<LENGTH;i++)
+        done[i]=0;
+
+      bool alldone = false;
+      if (epsset)
+        EPS0 /= interval;
 
-          bool alldone = false;
-          if (epsset)
-            EPS0 /= interval;
+      double epsilon = EPS0 / EPSF;
 
-          double epsilon = EPS0 / EPSF;
+      if (!clengthset)
+        CLENGTH=LENGTH;
+      octave_idx_type clength = ((CLENGTH*refstep+STEP) <= LENGTH) 
+                                ? CLENGTH : (LENGTH-STEP)/refstep;
 
-          if (!clengthset)
-            CLENGTH=LENGTH;
-          octave_idx_type clength = ((CLENGTH*refstep+STEP) <= LENGTH) 
-                                    ? CLENGTH : (LENGTH-STEP)/refstep;
+      // Compute estimates
+      octave_idx_type actfound;
+      octave_idx_type hi;
+      while (!alldone) {
+        alldone=1;
+        epsilon*=EPSF;
+        make_multi_box(input,box,list,LENGTH-(long)STEP,NMAX,dim,
+                       embed,DELAY,epsilon);
+        for (octave_idx_type i=(embed-1)*DELAY;i<clength;i++)
+          if (!done[i]) {
+          hi=i*refstep;
+          for (octave_idx_type j=0;j<dim;j++)
+            {
+//          old  hser[j]=series[j]+hi;
+              hser[j] = input.fortran_vec() + j * LENGTH + hi;
+            }
+          actfound=find_multi_neighbors(input,box,list,hser,NMAX,
+                                        dim,embed,DELAY,epsilon,hfound);
+          actfound=exclude_interval(actfound,hi-(long)causal+1,
+                              hi+causal+(embed-1)*DELAY-1,hfound,found);
+          if (actfound >= MINN)
+            {
+              if (setsort)
+                {
+                  sort(input, found, abstand, embed, DELAY, MINN,
+                       actfound, hser);
+                  actfound=MINN;
+                }
+              for (octave_idx_type j=1;j<=STEP;j++) {
+                make_fit(input,dim,hi,actfound,j,found,error_array,diffs);
+              }
+              done[i]=1;
+            }
+          alldone &= done[i];
+          }
+      }
 
-          // Compute estimates
-          octave_idx_type actfound;
-          octave_idx_type hi;
-          while (!alldone) {
-            alldone=1;
-            epsilon*=EPSF;
-            make_multi_box(input,box,list,LENGTH-(long)STEP,NMAX,dim,
-                           embed,DELAY,epsilon);
-            for (octave_idx_type i=(embed-1)*DELAY;i<clength;i++)
-              if (!done[i]) {
+      // Create relative forecast error output
+      Matrix rel_forecast_err (STEP, dim + 1);
+      for (octave_idx_type i=0;i<STEP;i++) 
+        {
+          rel_forecast_err(i,0) = i + 1;
+          for (octave_idx_type j=0;j<dim;j++) 
+            {
+         // old  fprintf(stdout,"%e ",
+         //         sqrt(error[j][i]/(clength-(embed-1)*DELAY))/rms[j]);
+              rel_forecast_err(i,j+1) = sqrt(error_array(i,j)
+                                      /(clength-(embed-1)*DELAY))/rms[j];
+            }
+        }
+
+      // Create individual forecast error output
+      Matrix ind_forecast_err (1,1);
+      if (nargout > 1)
+        {
+          ind_forecast_err.resize(clength - (embed-1)*DELAY, dim);
+          for (octave_idx_type i=(embed-1)*DELAY;i<clength;i++) 
+            {
               hi=i*refstep;
               for (octave_idx_type j=0;j<dim;j++)
                 {
-//              old  hser[j]=series[j]+hi;
-                  hser[j] = input.fortran_vec() + j * LENGTH + hi;
-                }
-              actfound=find_multi_neighbors(input,box,list,hser,NMAX,
-                                            dim,embed,DELAY,epsilon,hfound);
-              actfound=exclude_interval(actfound,hi-(long)causal+1,
-                                  hi+causal+(embed-1)*DELAY-1,hfound,found);
-              if (actfound >= MINN)
-                {
-                  if (setsort)
-                    {
-                      sort(input, found, abstand, embed, DELAY, MINN,
-                           actfound, hser);
-                      actfound=MINN;
-                    }
-                  for (octave_idx_type j=1;j<=STEP;j++) {
-                    make_fit(input,dim,hi,actfound,j,found,error_array,diffs);
-                  }
-                  done[i]=1;
-                }
-              alldone &= done[i];
-              }
-          }
-
-          // Create relative forecast error output
-          Matrix rel_forecast_err (STEP, dim + 1);
-          for (octave_idx_type i=0;i<STEP;i++) 
-            {
-              rel_forecast_err(i,0) = i + 1;
-              for (octave_idx_type j=0;j<dim;j++) 
-                {
-//            old  fprintf(stdout,"%e ",
-//                    sqrt(error[j][i]/(clength-(embed-1)*DELAY))/rms[j]);
-                  rel_forecast_err(i,j+1) = sqrt(error_array(i,j)
-                                          /(clength-(embed-1)*DELAY))/rms[j];
+                  // old fprintf(stdout,"%e ",diffs[j][hi]*hinter[j]);
+                  ind_forecast_err(i-(embed-1)*DELAY,j) = \
+                  diffs(hi,j)*hinter[j];
                 }
             }
+        }
 
-          // Create individual forecast error output
-          Matrix ind_forecast_err (1,1);
-          if (nargout > 1)
-            {
-              ind_forecast_err.resize(clength - (embed-1)*DELAY, dim);
-              for (octave_idx_type i=(embed-1)*DELAY;i<clength;i++) 
-                {
-                  hi=i*refstep;
-                  for (octave_idx_type j=0;j<dim;j++)
-                    {
-//                   old fprintf(stdout,"%e ",diffs[j][hi]*hinter[j]);
-                      ind_forecast_err(i-(embed-1)*DELAY,j) = \
-                      diffs(hi,j)*hinter[j];
-                    }
-                }
-            }
-
-          retval(0) = rel_forecast_err;
-          retval(1) = ind_forecast_err;
-        }
+      retval(0) = rel_forecast_err;
+      retval(1) = ind_forecast_err;
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__poincare__.cc
--- a/src/__poincare__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__poincare__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -129,19 +129,16 @@
 
 
 
-        if ( ! error_state)
-          {
-            Matrix output (out_size, embdim);
+      Matrix output (out_size, embdim);
 
-            octave_idx_type count = poincare (input.fortran_vec(), 
-                                              input.numel(), embdim,
-                                              delay, comp, where, direction,
-                                              output);
-            // Resize output to fit sections found
-            output.resize (count, embdim);
+      octave_idx_type count = poincare (input.fortran_vec(), 
+                                        input.numel(), embdim,
+                                        delay, comp, where, direction,
+                                        output);
+      // Resize output to fit sections found
+      output.resize (count, embdim);
 
-            retval(0) = output;
-          }
+      retval(0) = output;
     }
   return retval;
 }
